# -*- coding: utf-8 -*-

from rest_framework import serializers

from .. import models


class OrderSerializer(serializers.ModelSerializer):
    class Meta:
        model = models.Order
        fields = '__all__'


class OrderSerializerCreate(serializers.ModelSerializer):
    class Meta:
        model = models.Order
        exclude = ('date_create', 'date_last_modify', 'creator', 'last_modifier')


class OrderSerializerUpdate(serializers.ModelSerializer):
    class Meta:
        model = models.Order
        exclude = ('date_create', 'date_last_modify', 'creator', 'last_modifier')


class OrderRowSerializer(serializers.ModelSerializer):
    class Meta:
        model = models.OrderRow
        fields = '__all__'


class OrderRowSerializerCreate(serializers.ModelSerializer):
    class Meta:
        model = models.OrderRow
        exclude = ('date_create', 'date_last_modify', 'creator', 'last_modifier')


class OrderRowSerializerUpdate(serializers.ModelSerializer):
    class Meta:
        model = models.OrderRow
        exclude = ('date_create', 'date_last_modify', 'creator', 'last_modifier')
        

class VatRowSerializer(serializers.ModelSerializer):
    class Meta:
        model = models.VatRow
        fields = '__all__'


class VatRowSerializerCreate(serializers.ModelSerializer):
    class Meta:
        model = models.VatRow
        exclude = ('date_create', 'date_last_modify', 'creator', 'last_modifier')


class VatRowSerializerUpdate(serializers.ModelSerializer):
    class Meta:
        model = models.VatRow
        exclude = ('date_create', 'date_last_modify', 'creator', 'last_modifier')