# -*- coding: utf-8 -*-

# TODO: spostare nei mixin della thux.Invoice


# ORDER
@transaction.commit_manually
def create_or_append_to_invoice(self, invoice=None, date_i=date.today()):
    """
    Crea o aggiunge ad una Fattura le righe ordine
    """
    # Esce se l'ordine è già stato fatturato
    if self.is_allinvoiced():
        transaction.rollback()
        return

    orderrows = self.orderrows.filter(invoice=False, store_cause__ddt=False, store_cause__invoice=True)
    if not invoice:
        from jmb.invoice.models import Invoice
        invoice = Invoice(
            owner=self.owner, recipient=self.recipient,
            payment_form=self.payment_form,
            office=self.office, contact=self.contact,
            store_cause=self.store_cause, date_i=date_i,
        )
        invoice.save()

    for row in orderrows:
        row.add_to_invoice(invoice)

    if invoice.invoicerows.count() == 0:
        transaction.rollback()
        return False
    self.set_allinvoiced()
    transaction.commit()
    return True


def is_allinvoiced(self):
    """
    restituisce True se l'ordine è fatturato o se tutte le righe ordine sono fatturate
    """
    if self.invoice_completed:
        return True
    # Verifica se ci sono righe da fatturate
    rows = self.rows.filter(invoice=False, store_cause__invoice=True)
    return False if rows else True


def set_allinvoiced(self):
    """
    Imposta a True se tutte le righe ordine sono fatturate
    """
    if self.is_allinvoiced():
        self.invoice = True
        self.save()


# ORDER ROW
def get_invoicedquantity(self):
    """
    Restituisce la quantita totale fatturata
    """
    quantity = 0
    # se la riga ha una store_cause con ddt
    if self.store_cause.ddt:
        ddtrows = self.ddtrows.all()
        for row in ddtrows:
            quantity += row.get_invoicedquantity()
    # se la riga ha una store_cause senza ddt
    else:
        invoicerows = self.invoicerows.all()
        for row in invoicerows:
            quantity += row.quantity
    return quantity


def get_notinvoicedquantity(self):
    """
    Restituisce la quantita totale non fatturata
    """
    return self.quantity - self.get_invoicedquantity()
get_notinvoicedquantity.short_description = _('NI Quantity')


def force_as_invoiced(self):
    """
    Chiude una riga ordine in quanto non più da fatturare.
    ATTENZIONE! modifica la quantità ordinata
    """
    self.invoice = True
    self.quantity = self.quantity - self.get_notinvoicedquantity()
    self.save()


def create_or_append_to_invoice(self, invoice=None, date_i=date.today()):
    """
    Crea o aggiunge ad una Fattura la Riga Pratica
    """
    # Esce se la riga ordine è già stata fatturata
    if self.is_allinvoiced():
        return False, _('order row already invoiced')
    # TODO: da completare


def add_to_invoice(self, invoice, quantity=None, check_quantity=True):
    """
    Aggiunge la riga ordine a una Fattura.
    Solo la quantità passata viene inserita in Fattura.
    Se la quantità non è specificata l'intera quantità da fatturare viene inserita nella fattura
    """
    # TODO: vedere DDT - da completare
    notinvoicedquantity = self.get_notinvoicedquantity()
    if notinvoicedquantity <= 0:
        return False

    if not quantity:
        quantity = notinvoicedquantity

    if quantity > notinvoicedquantity:
        return False

    if not self.check_header_integrity(invoice):
        return False

    from jmb.invoice.models import InvoiceRow
    invoicerow = InvoiceRow(
        invoice=invoice, orderrow=self, product=self.product, vat=self.vat, store_cause=self.store_cause,
        quantity=quantity, price=self.price, fee=self.fee, discount=self.discount,
    )
    invoicerow.save()

    # Setta 'invoice_completed' se la quantità fatturata corrisponde alla quantita ordinata
    if quantity == notinvoicedquantity:
        self.invoice_completed = True
        self.save()


    if 'jmb.invoice' in settings.INSTALLED_APPS:
        @transaction.commit_manually
        def set_invoice(self, invoice=None, date_i=date.today(), quantity=None):
            '''
            crea o aggiunge ad una Fattura la Riga Pratica
            '''

            # TODO : la funzione e' sbagliata perche' usa ancora from invoice.utils import get_next_invoice_number
            # che non esiste
            pass

        #            ## se non viene passata una quantita fatturo tutto quello che deve essere ancora fatturato
        #            if not quantity:
        #                quantity = self.get_notinvoicedquantity()
        #
        #            ## se non ci sono quantita da fatturare esco
        #            if quantity <= 0:
        #                transaction.rollback()
        #                return None
        #
        #            from invoice.models import Invoice, InvoiceRow
        #
        #            ## se le Righe Pratica sono già fatturate esco
        #            if self.order.is_allinvoiced():
        #                transaction.rollback()
        #                return None
        #
        #            from invoice.utils import get_next_invoice_number
        #            try:
        #                ## se viene passato una Fattura
        #                if not (
        #                    invoice
        #                    and invoice.owner == self.order.owner
        #                    and invoice.recipient == self.order.recipient
        #                    and invoice.payment_form == self.order.payment_form
        #                ):
        #                    ## se l'anagrafica o la forma di pagamento non coincidono creo una nuova Fattura
        #                    invoice = Invoice(
        #                        owner=self.order.owner, recipient=self.order.recipient,
        #                        payment_form=self.order.payment_form,
        #                        office=self.order.office, contact=self.procedure.contact,
        #                        store_cause=self.order.store_cause, number=get_next_invoice_number(date_i), date_i=date_i,
        #                    )
        #                    invoice.save()
        #                invoicerow = InvoiceRow(
        #                    invoice=invoice, orderrow=self, product=self.product, vat=self.vat, store_cause=self.store_cause,
        #                    quantity=quantity, price=self.price, fee=self.fee, discount=self.discount,
        #                )
        #                invoicerow.save()
        #                ## se la quantita non ancora fatturata corrisponde alla quantita ordinata
        #                if quantity >= self.get_notdeliveredquantity():
        #                    self.invoice=True
        #                    self.save()
        #                ## verifico che tutte le righe della procedura siano state fatturate ed imposto self.order.invoice = true
        #                if self.order.is_allinvoiced():
        #                    self.order.invoice = True
        #                    self.order.save()
        #            except Exception, e:
        #                transaction.rollback()
        #            else:
        #                transaction.commit()
        #
        #            ## ritornare invoice: l'oggetto è utilizzato da order.set_invoice
        #            return invoice
