# -*- coding: utf-8 -*-

from django.conf.urls import url

from . import views

urlpatterns = [
    url(
        r'^detail_cart/$',
        views.CartDetailView.as_view(),
        name='detail_cart',
    ),
    url(
        r'^detail_cart_row/(?P<pk>\w+)/$',
        views.CartRowDetailView.as_view(),
        name='detail_cart_row',
    ),
    url(
        r'^add_product_to_cart/$',
        views.AddProductToCartView.as_view(),
        name='add_product_to_cart',
    ),
    url(
        r'^update_product_cart/$',
        views.UpdateProductCartView.as_view(),
        name='update_product_cart',
    ),
    url(
        r'^remove_product_from_cart/(?P<pk>\w+)/$',
        views.RemoveProductFromCartView.as_view(),
        name='remove_product_from_cart',
    ),
    url(
        r'^remove_cart/$',
        views.RemoveCartView.as_view(),
        name='remove_cart',
    ),
    url(
        r'^order_cart/$',
        views.OrderCartView.as_view(),
        name='order_cart',
    ),
    url(
        r'update_invoice_address_cart/$',
        views.UpdateInvoiceAddressCartView.as_view(),
        name='update_invoice_address_cart',
    ),
    url(
        r'update_shipping_address_cart/$',
        views.UpdateShippingAddressCartView.as_view(),
        name='update_shipping_address_cart',
    ),
    url(
        r'update_note_cart/$',
        views.UpdateNoteCartView.as_view(),
        name='update_note_cart',
    ),
    url(
        r'^list_order/$',
        views.OrderListView.as_view(),
        name='list_order',
    ),
    url(
        r'^detail_order/(?P<pk>\d+)/$',
        views.OrderDetailView.as_view(),
        name='detail_order',
    ),
    url(
        r'^list_order_row/(?P<order_id>\d+)/$',
        views.OrderRowListView.as_view(),
        name='list_order_row',
    ),
]
